Is it possible that ObjectSpace.dump_all catch dead objects?

10/14/2015 07:53 AM - gazay (Alex Gaziev)

Status: Closed   

Priority: Normal   

Assignee: tmm1 (Aman Karmani)   

Target version:    

ruby -v: 2.2.3p173 Backport: 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2:

UNKNOWN

Description

Koichi, can you please help. There are lines in a dump that are not referenced by anyone else. And these are not ROOTs. For

example, I'm looking in my dump by address of object and there is no other objects which have references to this object:

$ ag 0x7fc4adc55a20 dump.json

1812949:{"address":"0x7fc4adc55a20", "type":"DATA", "class":"0xaf6c70", "struct":"proc", "referenc

es":["0x7fc4adc55a48", "0x7fc504140390", "0x7fc4adc55a20", "0x7fc5041404d0"], "memsize":104}

 How can it be? Is it a dead object who got in a dump or am I missing something?

History

#1 - 10/14/2015 08:46 AM - gazay (Alex Gaziev)

- Description updated

- Assignee set to ko1 (Koichi Sasada)

#2 - 11/19/2015 06:40 AM - ko1 (Koichi Sasada)

It can be a bug of object traversing API. It is not well tested.

Do you have any script I can try?

@tmm1 (Aman Karmani) do you have any idea?

Thanks,

Koichi

#3 - 11/19/2015 08:16 AM - gazay (Alex Gaziev)

- File dead_thread.rb added

After running this example (dead_thread.rb) you can grep by printed address of thread and find out that it doesn't have parent

#4 - 11/19/2015 01:32 PM - ko1 (Koichi Sasada)

- Status changed from Open to Feedback

- Assignee changed from ko1 (Koichi Sasada) to tmm1 (Aman Karmani)

Sorry, last comment was my mistake.

ObjectSpace.dump_all() can output garbage (but not collected yet) objects.

This is current implementation.

     /* dump all objects */

    rb_objspace_each_objects(heap_i, &dc);

 This code is similar to ObjectSpace.each_object and it iterates uncollected objects. I'm not sure it is enough or not (but maybe it is okay).

#5 - 11/20/2015 06:30 AM - gazay (Alex Gaziev)

Ok, I understood. This issue can be closed now, thank you

#6 - 07/23/2019 07:06 PM - jeremyevans0 (Jeremy Evans)

07/16/2025 1/2

https://bugs.ruby-lang.org/users/390


- Status changed from Feedback to Closed

Files

dead_thread.rb 216 Bytes 11/19/2015 gazay (Alex Gaziev)
